Title:   Snappy Product Integration Agent
Version: 20151130

# Documentation

## Tutorial

Read latest version of the [tutorial](tutorial-products.html)

## Reference

- [Agent Reference](agent-reference-products.html)
- [API Reference](api-reference-products.html)

# Deprecated Organization-based Documentation

Per the 2015-11-24 release notes below, the Organizations-based workflows, API endpoints, etc. are now deprecated. Documents above cover the new usage scenarios where Product Integration is tied to a primary snap Package in the Store.

Further notice will be given before these deprecated workflows are removed entirely.

Documentation for the Organization-based workflows is still available here:

- [tutorial](tutorial.html)
- [Agent Reference](agent-reference.html)
- [API Reference](api-reference.html)


# SPI Agent Download

Download latest version: [agent.tar.gz](agent.tar.gz)

# Release Notes

## November 24 2015

* From this revision forward, new releases will only support the new organization-less workflows. Agent binaries from 2015-10-30 will continue to work as-is until further notice.

## October 30 2015

* Better and more detailed documentation

* More resilient SSH-to-the-RaspberryPi management

## October 27 2015

* The provisioning kit commands in the configuration file should be moved into
  a separate [provkit] section. Currently the agent will warn if they are still
  in the [config] section. For backwards compatibility, the old usage is still
  supported.

## October 15 2015

* Agent will retry network operations 3 times to mitigate transient failures.
* Agent will pass contents of the [environment] section of its configuration to
  the provisioning kit scripts as part of their environment.

## September 24 2015

* The SPI system now uses a single HTTPS endpoint: https://spi.canonical.com
  All other endpoints have been removed.
* Authentication is now mandatory for all API methods, unless otherwise stated
  in the API documentation.

## August 27 2015


* Agent doesn't provide default organization, configuring it is required
* Removed test credentials from tutorial, configuration is required
* By default, use the API gateway, so authentication is mandatory (can still use
  the alternative old URLs using older versions of the agent for
  non-auth access until next release)

## August 20 2015

SPI System/API changes:

The SPI system is introducing authentication and organizations.

Authentication is, at this point, only used by the agent (see below), and is not
mandatory for this cycle. In the next cycle authentication for the agent will become
mandatory.

Please start setting up accounts, and talk with your SPI contact to create your organization
and to connect your accounts to it.

Agent changes:

* The agent now supports authenticating using U1 accounts.
* To authenticate, use ./agent.py --interactive-login (more details in the documentation)
* Agent retries posting results to mitigate transient network failures

## August 7 2015

SPI System/API changes:

* Production is LIVE! New endpoints can be discovered with the ./agent.py --default-config and in the User Documentation.
* organization_id is no longer required in POST payloads (in the URL path now)
* manifest.base_image_reference, image.image_reference, test_spec.test_payload all allow arbitrary JSON values now.
* New Result Query APIs, see the User Documentation for details.
* Docs: the System Overview section has been extended to provide more information before having to delve into the API details.
* [BUG] Docs: fixed a number of incorrect examples.
* [BUG] Docs: clarified when Manifests are required/optional

Agent changes:

* [BUG] Provisioning kit scripts were not properly invoked with the spi_test_opportunity.json parameter
* New ./scripts/tutorial.py getting-started script
* Requires a config file to be specified now.
* Pass environment variables to provisioning kit

## July 31st 2015

New e2e test scripts, old e2e.py is now e2e-image.py, new e2e-snap-rev.py tests
the "announce a snap revision" workflow.

## July 21st 2015:

This version changes the names of two fields in the test opportunity data:

* image_url becomes image_reference
* image_hash becomes image_unique_id
